<!-- Spinner -->
<ngx-spinner [name]='"intent_report"' [fullScreen]="true" bdColor="#f5f5f583" size="medium" type="ball-fussion" color="#EDAE49"></ngx-spinner>

<div class="card dialog-content" style="padding: 2%;">
    <!-- Buttons -->
    <div class="button-container">
        <button mat-icon-button color="primary" (click)="resumeIntent(intent.id)" [disabled]="intent.not_fulfilled_state !== 'SUSPENDED'"
            matTooltip="Resume" matTooltipPosition="above">
            <mat-icon> play_arrow </mat-icon>
        </button>
        <button mat-icon-button color="primary" (click)="suspendIntent(intent.id)" [disabled]="intent.not_fulfilled_state === 'SUSPENDED' || intent.not_fulfilled_state === 'TERMINATED'"
        matTooltip="Suspend" matTooltipPosition="above">
            <mat-icon> stop </mat-icon>
        </button>
        <button mat-icon-button color="warn" (click)="terminateIntent(intent.id)" [disabled]="intent.not_fulfilled_state === 'TERMINATED'"
        matTooltip="Terminate" matTooltipPosition="above">
            <mat-icon> delete </mat-icon>
        </button>
    </div>

    <mat-divider></mat-divider>

    <!-- Info -->
    <div class="info-container">
        <div class="info-row">
            <span class="info-label">ID</span>
            <span class="info-value">: {{intent_data.id}} </span>
        </div>
        <div class="info-row">
            <span class="info-label">Name</span>
            <span class="info-value">: {{intent_data.name}} </span>
        </div>
        <div class="info-row">
            <span class="info-label">Feasibility</span>
            <span class="info-value">: {{intent_data.feasibility}} </span>
        </div>
        <div class="info-row" *ngIf="intent_data.infeasibility_reason !== null">
            <span class="info-label">Infeasibility Reason</span>
            <span class="info-value">: {{intent_data.infeasibility_reason}}</span>
        </div>
        <div class="info-row">
            <span class="info-label">Fulfilment Status</span>
            <span class="info-value">: {{intent_data.fulfilment_status}}</span>
        </div>
        <div class="info-row">
            <span class="info-label" *ngIf="intent_data.not_fulfilled_state !== null">Not Fulfilled State</span>
            <span class="info-value">: {{intent_data.not_fulfilled_state}}</span>
        </div>
        <div class="info-row">
            <span class="info-label">Last Updated Time</span>
            <span class="info-value">: {{intent_data.last_updated_time}}</span>
        </div>
    </div>

    <mat-divider></mat-divider>

    <!-- Form -->
    <form>
        <!-- Form First Row -->
        <div style="display: flex; justify-content: center;" class="row mb-10">
            
            <!-- Form First Column -->
            <div class="col-lg-6 col-xl-5 custom-border-right">
                <!-- Field: Workload Instace -->
                <label class="col-lg-12 col-form-label text-lg">Workload Instance ID *</label><br>
                <mat-form-field class="text-form-field" appearance="fill">
                    <input name="workload_instance_id" matInput type="text" [value]="intent_data.id" disabled/>
                </mat-form-field><br>

                <!-- Field: Intent Type  -->
                <label class="col-lg-12 col-form-label text-lg">Intent Type *</label><br>
                <mat-form-field class="text-form-field" appearance="fill">
                    <input name="intent_type" matInput type="text" [value]="intent_data.name" disabled/>
                </mat-form-field><br>  
            </div>

            <!-- Form Second Column -->
            <div class="col-lg-6 col-xl-5">
                <!-- Field: Start Time -->
                <label class="col-lg-12 col-form-label text-lg" *ngIf="intent?.intent_expectations?.[0]?.expectation_object?.object_contexts?.[0]?.context_value_range">Start Date-time</label><br>
                <mat-form-field class="datetime-form-field" appearance="fill" *ngIf="intent?.intent_expectations?.[0]?.expectation_object?.object_contexts?.[0]?.context_value_range">
                    <input matInput [ngxMatDatetimePicker]="start_picker" 
                    disabled [value]="(intent.intent_expectations[0].expectation_object.object_contexts[0].context_value_range | date:'yyyy-MM-ddTHH:mm:ss')">  
                    <mat-datepicker-toggle matSuffix [for]="$any(start_picker)"></mat-datepicker-toggle>
                    <ngx-mat-datetime-picker #start_picker [color]="'warn'"></ngx-mat-datetime-picker>
                </mat-form-field><br>

                <!-- Field: End Time -->
                <label class="col-lg-12 col-form-label text-lg" *ngIf="intent?.intent_expectations?.[0]?.expectation_object?.object_contexts?.[1]?.context_value_range">End Date-time</label><br>
                <mat-form-field class="datetime-form-field" appearance="fill" *ngIf="intent?.intent_expectations?.[0]?.expectation_object?.object_contexts?.[1]?.context_value_range">
                    <input matInput readonly [ngxMatDatetimePicker]="end_picker"
                    disabled [value]="(intent.intent_expectations[0].expectation_object.object_contexts[1].context_value_range | date:'yyyy-MM-ddTHH:mm:ss')">
                    <mat-datepicker-toggle matSuffix [for]="$any(end_picker)"></mat-datepicker-toggle>
                    <ngx-mat-datetime-picker #end_picker [color]="'warn'"> </ngx-mat-datetime-picker>
                </mat-form-field><br>
            </div>
        </div>
        <!-- Target Labels -->
        <div style="display: flex; justify-content: center;" class="row mb-10">
            <div class="col-lg-12 col-xl-10">
                <div class="row">
                    <div class="col-lg-4">
                        <label class="col-lg-12 col-form-label text-lg">Target Name</label><br>
                    </div>
                    <div class="col-lg-3">
                        <label class="col-lg-12 col-form-label text-lg">Target Condition</label><br>
                    </div>
                    <div class="col-lg-4">
                        <label class="col-lg-12 col-form-label text-lg">Target Value</label><br>
                    </div>
                </div>
            </div>
        </div>
        <!-- Targets -->
        <div style="display: flex; justify-content: center;" class="row mb-10">
            <div class="col-lg-12 col-xl-10">
                <div *ngFor="let target of intent.intent_expectations[0].expectation_targets; let iarr = index">
                    <div class="row">
                        <div class="col-lg-4">
                            <mat-form-field class="text-form-field-targ" appearance="fill">
                                <input name="target_name" matInput type="text" [value]="target.target_name" disabled/>
                            </mat-form-field><br>
                        </div>
                        <div class="col-lg-3">
                            <mat-form-field class="text-form-field-targ" appearance="fill">
                                <input name="target_condition" matInput type="text" [value]="target.target_condition" disabled/>
                            </mat-form-field><br>
                        </div>
                        <div class="col-lg-4">
                            <mat-form-field class="text-form-field-targ status-tag" appearance="fill">
                                <!-- <mat-label>Achieved Value: {{intent_data.target_fulfilment_results[iarr].target_achieved_value ?? '-'}}</mat-label> -->
                                <input name="target_value_range" matInput type="text" [value]="target.target_value_range" [disabled]="targets_disabled[iarr]"/>
                                <mat-chip *ngIf="intent_data?.target_fulfilment_results[iarr].target_fulfilment_info.fulfilment_status === 'FULFILLED'"
                                    class="status-chip" matTooltipPosition="above" matTooltipClass="multiline-tooltip" style="background-color: green;"
                                    [matTooltip]="getTargetTooltip(iarr)">
                                    {{ intent_data?.target_fulfilment_results[iarr].target_fulfilment_info.fulfilment_status }}
                                </mat-chip>
                                <mat-chip *ngIf="intent_data?.target_fulfilment_results[iarr].target_fulfilment_info.fulfilment_status === 'NOT_FULFILLED'"
                                    class="status-chip" matTooltipPosition="above" matTooltipClass="multiline-tooltip" style="background-color: red;"
                                    [matTooltip]="getTargetTooltip(iarr)">
                                    {{ intent_data?.target_fulfilment_results[iarr].target_fulfilment_info.fulfilment_status }}
                                </mat-chip>
                            </mat-form-field><br>
                        </div>
                        <div class="col-lg-1 d-flex align-items-start justify-content-center gap-2">
                            <button type="button" mat-raised-button id="removeFormField_button" class="btn-rem flex-shrink-0" (click)="editTarget(target, iarr)">
                                <mat-icon>edit</mat-icon>
                            </button>
                            <button type="button" mat-raised-button id="removeFormField_button" class="btn-rem flex-shrink-0" (click)="saveTarget(target, iarr, $event)" [disabled]="targets_disabled[iarr]">
                                <mat-icon>save</mat-icon>
                            </button>
                        </div>
                    </div>
                </div>
            </div>
        </div>

    </form>






    <!-- <pre>{{ intent | json }}</pre> -->
</div>


